library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.ipbus.all;
use work.ipbus_reg_types.all;

use work.emp_data_types.all;
use work.mprocessor_constants.all;


entity EcalLinkInterface is

port (
    --- Input Ports ---
    clk_p            : in  std_logic;
    link_in          : in  lword := LWORD_NULL;
    --- Output Ports ---
    link_out         : out lword := LWORD_NULL;
    ecal_out          : out tDaqEcalLinkData
);
end EcalLinkInterface;

architecture rtl of EcalLinkInterface is

begin

link_out.data <= (others => '0');

--==============================--
EcalDataDecoder : entity work.EcalDataDecoder
--==============================--
port map(
       --- Input Ports ---
        clk_p            => clk_p,
        data_in          => link_in,
        --- Output Ports ---
        ecal_out         => ecal_out
);

end rtl;

