# 40 MHz external oscillator from Artix
set lLegacyTtcClockPort [get_ports -quiet ttc_clk_p]
if {[llength $lLegacyTtcClockPort] != 0} {
    create_clock -name clk_40_extern_i0 -period 25.000 $lLegacyTtcClockPort
}

# 320 MHz TCDS2 clock
set lTcdsClockPort [get_ports -quiet tcds_clk_p]
if {[llength $lTcdsClockPort] != 0} {
    create_clock -name tcds_clk -period 3.125 $lTcdsClockPort
}

# KH for slink
if { [llength [get_cells slink_check.slink]] > 0 } { 
    set index [get_property ref_clock_index [get_cells slink_check.slink]]
    puts "slink ==> refclk index : $index"
    set reffreq [get_property ref_clock_freq [get_cells slink_check.slink]]
    puts "slink ==> refclk freq : $reffreq"
    set refprd [expr 1000/$reffreq]
    puts "slink ==> refclk period : $refprd"
}

# DGM for eth10g
if { [llength [get_cells eth10g_interface]] > 0 } { 
    set eth10g_index [get_property ref_clock_index [get_cells eth10g_interface]]
    puts "eth10g ==> refclk index : $eth10g_index"
    set  eth10g_reffreq [get_property ref_clock_freq [get_cells eth10g_interface]]
    puts "eth10g ==> refclk freq : $eth10g_reffreq"
    set  eth10g_refprd [expr 1000/$eth10g_reffreq]
    puts "eth10g ==> refclk period : $eth10g_refprd"
}

# MGT refclks
set lRefClkSize [llength [get_ports {refclkn[*]}]]
for {set i 0} {$i < $lRefClkSize} {incr i} {
    # KH modify for slink
    if { [llength [get_cells slink_check.slink]] > 0 } { 
        if { $i == $index } { 
            create_clock -name refclk_$i -period $refprd [get_ports refclkn[$i]]
        } else { 
            create_clock -name refclk_$i -period 3.125 [get_ports refclkn[$i]]
        }
    } elseif {[llength [get_cells eth10g_interface]] > 0} {
        if { $i == $eth10g_index } {
            # DGM commented out as hack - reason for timing issues when uncommented unclear
            # create_clock -name refclk_$i -period $eth10g_refprd [get_ports refclkn[$i]]
        } else { 
            create_clock -name refclk_$i -period 3.125 [get_ports refclkn[$i]]
        }
    } else {
        create_clock -name refclk_$i -period 3.125 [get_ports refclkn[$i]]
    }
}
